diff --git a/MAINTAINERS b/MAINTAINERS
index fb6c3a6..48b0a7b 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -202,7 +202,7 @@ S390
 M: Richard Henderson <rth@twiddle.net>
 M: Alexander Graf <agraf@suse.de>
 S: Maintained
-F: target-s390x/
+F: target/s390x/
 F: hw/s390x/
 F: disas/s390.c
 
@@ -286,9 +286,9 @@ M: Christian Borntraeger <borntraeger@de.ibm.com>
 M: Cornelia Huck <cornelia.huck@de.ibm.com>
 M: Alexander Graf <agraf@suse.de>
 S: Maintained
-F: target-s390x/kvm.c
-F: target-s390x/ioinst.[ch]
-F: target-s390x/machine.c
+F: target/s390x/kvm.c
+F: target/s390x/ioinst.[ch]
+F: target/s390x/machine.c
 F: hw/intc/s390_flic.c
 F: hw/intc/s390_flic_kvm.c
 F: include/hw/s390x/s390_flic.h
diff --git a/Makefile.objs b/Makefile.objs
index 91a24c5..c5ebb80 100644
--- a/Makefile.objs
+++ b/Makefile.objs
@@ -158,7 +158,7 @@ trace-events-y += net/trace-events
 trace-events-y += target/arm/trace-events
 trace-events-y += target/i386/trace-events
 trace-events-y += target-sparc/trace-events
-trace-events-y += target-s390x/trace-events
+trace-events-y += target/s390x/trace-events
 trace-events-y += target/ppc/trace-events
 trace-events-y += qom/trace-events
 trace-events-y += linux-user/trace-events
diff --git a/target-s390x/Makefile.objs b/target/s390x/Makefile.objs
similarity index 94%
rename from target-s390x/Makefile.objs
rename to target/s390x/Makefile.objs
index 6b02b17..c573633 100644
--- a/target-s390x/Makefile.objs
+++ b/target/s390x/Makefile.objs
@@ -5,7 +5,7 @@ obj-$(CONFIG_SOFTMMU) += machine.o ioinst.o arch_dump.o mmu_helper.o
 obj-$(CONFIG_KVM) += kvm.o
 
 # build and run feature list generator
-feat-src = $(SRC_PATH)/target-$(TARGET_BASE_ARCH)/
+feat-src = $(SRC_PATH)/target/$(TARGET_BASE_ARCH)/
 feat-dst = $(BUILD_DIR)/$(TARGET_DIR)
 ifneq ($(MAKECMDGOALS),clean)
 GENERATED_HEADERS += $(feat-dst)gen-features.h
diff --git a/target-s390x/arch_dump.c b/target/s390x/arch_dump.c
similarity index 100%
rename from target-s390x/arch_dump.c
rename to target/s390x/arch_dump.c
diff --git a/target-s390x/cc_helper.c b/target/s390x/cc_helper.c
similarity index 100%
rename from target-s390x/cc_helper.c
rename to target/s390x/cc_helper.c
diff --git a/target-s390x/cpu-qom.h b/target/s390x/cpu-qom.h
similarity index 100%
rename from target-s390x/cpu-qom.h
rename to target/s390x/cpu-qom.h
diff --git a/target-s390x/cpu.c b/target/s390x/cpu.c
similarity index 100%
rename from target-s390x/cpu.c
rename to target/s390x/cpu.c
diff --git a/target-s390x/cpu.h b/target/s390x/cpu.h
similarity index 100%
rename from target-s390x/cpu.h
rename to target/s390x/cpu.h
diff --git a/target-s390x/cpu_features.c b/target/s390x/cpu_features.c
similarity index 100%
rename from target-s390x/cpu_features.c
rename to target/s390x/cpu_features.c
diff --git a/target-s390x/cpu_features.h b/target/s390x/cpu_features.h
similarity index 100%
rename from target-s390x/cpu_features.h
rename to target/s390x/cpu_features.h
diff --git a/target-s390x/cpu_features_def.h b/target/s390x/cpu_features_def.h
similarity index 100%
rename from target-s390x/cpu_features_def.h
rename to target/s390x/cpu_features_def.h
diff --git a/target-s390x/cpu_models.c b/target/s390x/cpu_models.c
similarity index 100%
rename from target-s390x/cpu_models.c
rename to target/s390x/cpu_models.c
diff --git a/target-s390x/cpu_models.h b/target/s390x/cpu_models.h
similarity index 100%
rename from target-s390x/cpu_models.h
rename to target/s390x/cpu_models.h
diff --git a/target-s390x/fpu_helper.c b/target/s390x/fpu_helper.c
similarity index 100%
rename from target-s390x/fpu_helper.c
rename to target/s390x/fpu_helper.c
diff --git a/target-s390x/gdbstub.c b/target/s390x/gdbstub.c
similarity index 100%
rename from target-s390x/gdbstub.c
rename to target/s390x/gdbstub.c
diff --git a/target-s390x/gen-features.c b/target/s390x/gen-features.c
similarity index 100%
rename from target-s390x/gen-features.c
rename to target/s390x/gen-features.c
diff --git a/target-s390x/helper.c b/target/s390x/helper.c
similarity index 100%
rename from target-s390x/helper.c
rename to target/s390x/helper.c
diff --git a/target-s390x/helper.h b/target/s390x/helper.h
similarity index 100%
rename from target-s390x/helper.h
rename to target/s390x/helper.h
diff --git a/target-s390x/insn-data.def b/target/s390x/insn-data.def
similarity index 100%
rename from target-s390x/insn-data.def
rename to target/s390x/insn-data.def
diff --git a/target-s390x/insn-format.def b/target/s390x/insn-format.def
similarity index 100%
rename from target-s390x/insn-format.def
rename to target/s390x/insn-format.def
diff --git a/target-s390x/int_helper.c b/target/s390x/int_helper.c
similarity index 100%
rename from target-s390x/int_helper.c
rename to target/s390x/int_helper.c
diff --git a/target-s390x/interrupt.c b/target/s390x/interrupt.c
similarity index 100%
rename from target-s390x/interrupt.c
rename to target/s390x/interrupt.c
diff --git a/target-s390x/ioinst.c b/target/s390x/ioinst.c
similarity index 100%
rename from target-s390x/ioinst.c
rename to target/s390x/ioinst.c
diff --git a/target-s390x/kvm.c b/target/s390x/kvm.c
similarity index 100%
rename from target-s390x/kvm.c
rename to target/s390x/kvm.c
diff --git a/target-s390x/machine.c b/target/s390x/machine.c
similarity index 100%
rename from target-s390x/machine.c
rename to target/s390x/machine.c
diff --git a/target-s390x/mem_helper.c b/target/s390x/mem_helper.c
similarity index 100%
rename from target-s390x/mem_helper.c
rename to target/s390x/mem_helper.c
diff --git a/target-s390x/misc_helper.c b/target/s390x/misc_helper.c
similarity index 100%
rename from target-s390x/misc_helper.c
rename to target/s390x/misc_helper.c
diff --git a/target-s390x/mmu_helper.c b/target/s390x/mmu_helper.c
similarity index 100%
rename from target-s390x/mmu_helper.c
rename to target/s390x/mmu_helper.c
diff --git a/target-s390x/trace-events b/target/s390x/trace-events
similarity index 91%
rename from target-s390x/trace-events
rename to target/s390x/trace-events
index df59f5f..1574033 100644
--- a/target-s390x/trace-events
+++ b/target/s390x/trace-events
@@ -1,22 +1,22 @@
 # See docs/tracing.txt for syntax documentation.
 
-# target-s390x/mmu_helper.c
+# target/s390x/mmu_helper.c
 get_skeys_nonzero(int rc) "SKEY: Call to get_skeys unexpectedly returned %d"
 set_skeys_nonzero(int rc) "SKEY: Call to set_skeys unexpectedly returned %d"
 
-# target-s390x/ioinst.c
+# target/s390x/ioinst.c
 ioinst(const char *insn) "IOINST: %s"
 ioinst_sch_id(const char *insn, int cssid, int ssid, int schid) "IOINST: %s (%x.%x.%04x)"
 ioinst_chp_id(const char *insn, int cssid, int chpid) "IOINST: %s (%x.%02x)"
 ioinst_chsc_cmd(uint16_t cmd, uint16_t len) "IOINST: chsc command %04x, len %04x"
 
-# target-s390x/kvm.c
+# target/s390x/kvm.c
 kvm_enable_cmma(int rc) "CMMA: enabling with result code %d"
 kvm_clear_cmma(int rc) "CMMA: clearing with result code %d"
 kvm_failed_cpu_state_set(int cpu_index, uint8_t state, const char *msg) "Warning: Unable to set cpu %d state %" PRIu8 " to KVM: %s"
 kvm_sigp_finished(uint8_t order, int cpu_index, int dst_index, int cc) "SIGP: Finished order %u on cpu %d -> cpu %d with cc=%d"
 
-# target-s390x/cpu.c
+# target/s390x/cpu.c
 cpu_set_state(int cpu_index, uint8_t state) "setting cpu %d state to %" PRIu8
 cpu_halt(int cpu_index) "halting cpu %d"
 cpu_unhalt(int cpu_index) "unhalting cpu %d"
diff --git a/target-s390x/translate.c b/target/s390x/translate.c
similarity index 100%
rename from target-s390x/translate.c
rename to target/s390x/translate.c